'use strict';

exports.__esModule = true;
exports.default = getFn;

var _chai = require('chai');

function getFn(command) {
    switch (command.assertionType) {
        case 'eql':
            return () => _chai.assert.deepEqual(command.actual, command.expected, command.message);

        case 'notEql':
            return () => _chai.assert.notDeepEqual(command.actual, command.expected, command.message);

        case 'ok':
            return () => _chai.assert.isOk(command.actual, command.message);

        case 'notOk':
            return () => _chai.assert.isNotOk(command.actual, command.message);

        case 'contains':
            return () => _chai.assert.include(command.actual, command.expected, command.message);

        case 'notContains':
            return () => _chai.assert.notInclude(command.actual, command.expected, command.message);

        case 'typeOf':
            return () => _chai.assert.typeOf(command.actual, command.expected, command.message);

        case 'notTypeOf':
            return () => _chai.assert.notTypeOf(command.actual, command.expected, command.message);

        case 'gt':
            return () => _chai.assert.isAbove(command.actual, command.expected, command.message);

        case 'gte':
            return () => _chai.assert.isAtLeast(command.actual, command.expected, command.message);

        case 'lt':
            return () => _chai.assert.isBelow(command.actual, command.expected, command.message);

        case 'lte':
            return () => _chai.assert.isAtMost(command.actual, command.expected, command.message);

        case 'within':
            return () => (0, _chai.expect)(command.actual).to.be.within(command.expected, command.expected2, command.message);

        case 'notWithin':
            return () => (0, _chai.expect)(command.actual).not.to.be.within(command.expected, command.expected2, command.message);

        case 'match':
            return () => _chai.assert.match(command.actual, command.expected, command.message);

        case 'notMatch':
            return () => _chai.assert.notMatch(command.actual, command.expected, command.message);

        default:
            return () => {};
    }
}
module.exports = exports['default'];