'use strict';

exports.__esModule = true;

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _tmp = require('tmp');

var _tmp2 = _interopRequireDefault(_tmp);

var _promisifiedFunctions = require('../../../../utils/promisified-functions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (() => {
    var _ref = (0, _asyncToGenerator3.default)(function* (proxyHostName) {
        _tmp2.default.setGracefulCleanup();

        const tempDir = _tmp2.default.dirSync({ unsafeCleanup: true });
        const profileDirName = _path2.default.join(tempDir.name, 'Default');

        yield (0, _promisifiedFunctions.ensureDir)(profileDirName);

        const preferences = {
            'credentials_enable_service': false,

            'devtools': {
                'preferences': {
                    'currentDockState': '"undocked"',
                    'lastDockState': '"bottom"'
                }
            },

            'profile': {
                'content_settings': {
                    'exceptions': {
                        'automatic_downloads': {
                            [proxyHostName]: { setting: 1 }
                        }
                    }
                },

                'password_manager_enabled': false
            },

            'translate': {
                'enabled': false
            }
        };

        yield (0, _promisifiedFunctions.writeFile)(_path2.default.join(profileDirName, 'Preferences'), (0, _stringify2.default)(preferences));
        yield (0, _promisifiedFunctions.writeFile)(_path2.default.join(tempDir.name, 'First Run'), '');

        return tempDir;
    });

    return function (_x) {
        return _ref.apply(this, arguments);
    };
})();

module.exports = exports['default'];