'use strict';

exports.__esModule = true;

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

let getTempProfile = (() => {
    var _ref = (0, _asyncToGenerator3.default)(function* (proxyHostName, config) {

        var tempProfile = commonTempProfile;
        var shouldUseCommonProfile = !config.headless && !config.emulation;

        if (!shouldUseCommonProfile || !commonTempProfile) tempProfile = yield (0, _createTempProfile2.default)(proxyHostName);

        if (shouldUseCommonProfile && !commonTempProfile) commonTempProfile = tempProfile;

        return tempProfile;
    });

    return function getTempProfile(_x, _x2) {
        return _ref.apply(this, arguments);
    };
})();

var _endpointUtils = require('endpoint-utils');

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

var _createTempProfile = require('./create-temp-profile');

var _createTempProfile2 = _interopRequireDefault(_createTempProfile);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var commonTempProfile = null;

exports.default = (() => {
    var _ref2 = (0, _asyncToGenerator3.default)(function* (proxyHostName, configString) {
        var config = (0, _config2.default)(configString);
        var tempProfileDir = !config.userProfile ? yield getTempProfile(proxyHostName, config) : null;
        var cdpPort = config.cdpPort || (!config.userProfile ? yield (0, _endpointUtils.getFreePort)() : null);

        return { config, cdpPort, tempProfileDir };
    });

    return function (_x3, _x4) {
        return _ref2.apply(this, arguments);
    };
})();

module.exports = exports['default'];