'use strict';

exports.__esModule = true;

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _indentString = require('indent-string');

var _indentString2 = _interopRequireDefault(_indentString);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class TestRunDebugLog {
    constructor(userAgent) {
        this.driverMessageLogger = (0, _debug2.default)(`testcafe:test-run:${userAgent}:driver-message`);
        this.commandLogger = (0, _debug2.default)(`testcafe:test-run:${userAgent}:command`);
    }

    static _addEntry(logger, data) {
        var entry = data ? (0, _indentString2.default)(`\n${(0, _stringify2.default)(data, null, 2)}\n`, ' ', 4) : '';

        logger(entry);
    }

    driverMessage(msg) {
        TestRunDebugLog._addEntry(this.driverMessageLogger, msg);
    }

    command(cmd) {
        TestRunDebugLog._addEntry(this.commandLogger, cmd);
    }
}
exports.default = TestRunDebugLog;
module.exports = exports['default'];