'use strict';

exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

class Assignable {
    _getAssignableProperties() {
        throw new Error('Not implemented');
    }

    _assignFrom(obj, validate, initOptions = {}) {
        if (!obj) return;

        var props = this._getAssignableProperties();

        for (var i = 0; i < props.length; i++) {
            var _props$i = props[i],
                name = _props$i.name,
                type = _props$i.type,
                required = _props$i.required,
                init = _props$i.init,
                defaultValue = _props$i.defaultValue;


            var path = name.split('.');
            var lastIdx = path.length - 1;
            var last = path[lastIdx];
            var srcObj = obj;
            var destObj = this;

            for (var j = 0; j < lastIdx && srcObj && destObj; j++) {
                srcObj = srcObj[path[j]];
                destObj = destObj[path[j]];
            }

            if (destObj && 'defaultValue' in props[i]) destObj[name] = defaultValue;

            if (srcObj && destObj) {
                var srcVal = srcObj[last];

                if (srcVal !== void 0 || required) {
                    if (validate && type) type(name, srcVal);

                    destObj[last] = init ? init(name, srcVal, initOptions) : srcVal;
                }
            }
        }
    }
}
exports.default = Assignable;
module.exports = exports['default'];